#!/usr/bin/env python


#         Gnome-Print  > 0.25
#           ,  gnome-print, , gnumeric  sodipodi

#   ,          *.afm  *.pfb
#  ,       ,    type1inst      
#   Fontmap (   GhostScript)  fonts.dir  fonts.scale (    xfs).
#    ""            gnome-print,
# ghostscript  xfs.             , , 
#                 .

#     gnome-print     /usr/share/fonts/fontmap2
#      (  ./fontmap2.add),     
#  /usr/share/fonts/fontmap2    xml, . .    <fontmap> ...  </fonmap>
#       root.
#  , gnome-print      ,         
#  (    /usr/share/fonts/)      .        
#  .

#       gnome-font-install -t ./fontmap2.add <path to your fonts>
#       ,         .

#   .   
# *       *.afm CharacterSet yrillic
# *      *.afm   gnome-font-install (   )
# *         latin -1 (   255) 
# ,     .


#      Gnome-Print
#   type1 *.pfb  *.afm    (     /usr/share/fonts/myfonts )
#    ( 8.3,  ,   ,    root,  644)
#     .
#    perl  replace.   CharacterSet Cyrillic   *.afm. !!! ,   .
#     type1inst
#            xfs (chkfontpath --add <fontdir>)  ( )  gs (export GS_LIB=$GS_LIB;<fontdir>) 
#  cp ./fonts.scale ./fonts.dir 
#            (   ! "./"       ) 
#   
#   ./fontmap2.add        .
#      ./usr/share/fonts/fontmap2    (         
#     .      .
#     cat ./fontmap2.add >> ../fontmap2; vi ../fontmap2    </fontmap>  .

# 
#                *.afm.
#  :  search   [x:y]         .
#     .         .
#              
#        . 
#               . 
#                .
#    ,     ,  . 

#      (AVL) avl@l14.ru
#     gnome-print  gs    (AEN),      
#      
#            mandrake-russian, sisyphus  www.altlinux.ru 
#    .

import os
import string
import sys


#     .

FontPath='/usr/share/fonts/paratype/'

#   .     -        . 

OutFile='./fontmap2.add'


#   .  .

FullName = '';
FontName = '';
FamilyName = '';
ItalicAngle = '';
Version = '';
Weight='';
FileAfm='';
FilePfb='';
AfmSize='';
PfbSize='';
AfmMtime='';
PfbMtime='';
PsName='';
SpeciesName='';

Font_Xml_Record='<font format="type1" name="%FullName%" version="%Version%" familyname="%FamilyName%" speciesname="%SpeciesName%" psname="%PsName%" weight="%Weight%" italicangle="%ItalicAngle%">\n\
    <file type="afm" path="%FileAfm%" size="%AfmSize%" mtime="%AfmMtime%"/>\n\
    <file type="pfb" path="%FilePfb%" size="%PfbSize%" mtime="%PfbMtime%"/>\n\
</font>\n';

	    


files = os.listdir('./')  # ,       *.afm?


of = open(OutFile, 'w')

for i in files:
    if i[-3:] == 'afm':
	FullName = '';
	FontName = '';
	FamilyName = '';
	ItalicAngle = '';
	Version = '';
	Weight='';
	f = open(FontPath+i, 'r')
	s = f.readline()
	while s[:16] <> 'StartCharMetrics':
	    if s[:8] == 'FullName':
        	FullName = s[9:].strip()
	    elif s[:8] == 'FontName':
		FontName = s[9:].strip()
	    elif s[:10] == 'FamilyName':
		FamilyName = s[11:].strip()
	    elif s[:11] == 'ItalicAngle':
		ItalicAngle = s[12:].strip()
	    elif s[:7] == 'Version':
		Version = s[8:].strip()
#	    elif s[:6] == 'Weight':                    #   *.afm   
#		Weight = s[7:].strip()                 #    ,   type1inst ( .)
	    FileAfm = i;
	    FilePfb = string.replace(i,'.afm','.pfb');  #  .  ,  pfb  afm   .
	    s = f.readline()
	f.close()
	
	FontMapFile = open(FontPath+'Fontmap','r')
	while 1:
	    temp=FontMapFile.readline();
	    if not temp:
		break;
	    try:
    		string.index(temp,FilePfb)
		PsName = temp[1:40].strip()            # .   Fontmap      40 
	    except:
	        pass;

	FontMapFile.close;

	FontsDirFile = open(FontPath+'fonts.dir','r')
	while 1:
	    temp=FontsDirFile.readline();
	    if not temp:
		break;
	    try:
    		string.index(temp,FilePfb)
		temp = temp[string.index(temp,' -')+2:]
		temp = temp[string.index(temp,'-')+1:]
		temp = temp[string.index(temp,'-')+1:]
		SpeciesName = temp[:string.index(temp,'-')]
		temp = temp[string.index(temp,'-')+1:]
		Weight = temp[:string.index(temp,'-')]
		if Weight == 'i' :
		    Weight = 'italic'
		elif Weight == 'o' :
		    Weight = 'oblique'
		elif Weight == 'r' :
		    Weight = 'regular'
		else :
		    Weight = 'error'			 # .       fonts.dir  .  ?
	    except:
	        pass;

	FontsDirFile.close;


        StatAfm=os.stat(FileAfm);
	AfmSize=str(StatAfm[6]);
	AfmMtime=str(StatAfm[8]);
	
        StatPfb=os.stat(FilePfb);
	PfbSize=str(StatPfb[6]);
	PfbMtime=str(StatPfb[8]);

	temp = Font_Xml_Record;
	temp = string.replace(temp,'%FullName%',FullName);
	temp = string.replace(temp,'%FontName%',FontName);
	temp = string.replace(temp,'%FamilyName%',FamilyName);
	temp = string.replace(temp,'%ItalicAngle%',ItalicAngle);
	temp = string.replace(temp,'%Version%',Version);
	temp = string.replace(temp,'%Weight%',Weight);
	temp = string.replace(temp,'%FileAfm%',FontPath+FileAfm);
	temp = string.replace(temp,'%AfmSize%',AfmSize);
	temp = string.replace(temp,'%AfmMtime%',AfmMtime);
	temp = string.replace(temp,'%FilePfb%',FontPath+FilePfb);
	temp = string.replace(temp,'%PfbSize%',PfbSize);
	temp = string.replace(temp,'%PfbMtime%',PfbMtime);
	temp = string.replace(temp,'%PsName%',PsName);
	temp = string.replace(temp,'%SpeciesName%',SpeciesName);

	print FullName, FontName, FamilyName	
	
	of.write(temp);

of.close()    
																	     
																																		     
																																		     